/****
 O2.CMD v2.1 (REXX) for OS/2 [XYOS2SHL.ZIP]
 Start OS/2 [DOS|WIN3x] process from XyWrite
 O2.CMD v2 requires RexxUtil.DLL version 2.00+
 R.J.Holmgren  Freeware  6/3/96 Rev.5/20/02 PW273DIRM273DI

 Non-STARTOS2 command line switches:
 /E                       Turn ECHO ON during execution
 /H                       Halt before exiting shell
 /I                       Ignore O2-ALIAS.DAT (omit alias query)
 /L                       Monitor newest program|object until inactive
 /L:launch_program        Monitor "launch_program"|object until inactive
 /L:"program to launch"     ditto
 /LW:decimal_seconds      Wait for Monitored program x seconds (default=4)
 /P:exit_process_title    On-the-fly "ExitProc" definition
 /P:"exit process title"    ditto
 /P:#                     Launch but do NOT return (exit immediately)
 /R                       Execute as REXX script, not batch commands
****/

/* Hard-Coded "Case" Variable:
ExitProc Case SeNsItIvE(=1) or INsensitive(=0,Default) ? */
case=0

/* Load RexxUtil v2.00 */
if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
if RxFuncQuery("SysQuerySwitchList") then do
  say 'O2.CMD v2.0 requires RexxUtil.DLL version 2.00+'
  call Help
  end

call SysSetPriority 2,31
call rxqueue "delete","SWO2"
signal on halt name AB
signal on SYNTAX

/* Set|Verify filenames */
BootDrive=SysBootDrive()
if pos(':',BootDrive)\=2 then call Help
IniFile=BootDrive||'\OS2\MDOS\O2.INI'
currdir=directory()

call linein IniFile,1,0 /* (Re)Set Read/Write Position */
if lines(IniFile)=0 then call Help

args=linein(IniFile) /* Read O2.INI */
ucargs=translate(args)
monargs=translate(linein(IniFile))
Command=linein(IniFile)

comsp=value('COMSPEC',,'OS2ENVIRONMENT')
x=pos('%COMSPEC%',Command)
if x>0 then Command=left(Command,x-1)||comsp||substr(Command,x+9)
x=pos('%ROOT%',Command)
if x>0 then Command=left(Command,x-1)||BootDrive||'\'||substr(Command,x+6)

agin: /* Get environment %VARIABLES% in Command, if exist */
if pos('%',Command)>0 then do
  TmpCmnd=substr(Command,pos('%',Command)+1)
  if pos('%',TmpCmnd)>0 then do
    TmpCmnd=left(TmpCmnd,pos('%',TmpCmnd)-1)
    x=value(TmpCmnd,,'OS2ENVIRONMENT')
    if length(x)>0 then do
      Command=left(Command,pos('%',Command)-1)||x||substr(Command,pos('%',Command)+length(TmpCmnd)+2)
      signal agin
      end
    end
  end

call stream IniFile,'C','close'

/* Read user input (O2 args) */
sessname=substr(args,2,pos('" ',args)-2)

hold=0; if pos('/H',ucargs)>0 then hold=1

if pos('/E',ucargs)>0 then '@echo on'
else '@echo off'

backon=0; if pos('/B',ucargs)>0 then backon=1

rexxon=0; if pos('/R',ucargs)>0 then rexxon=1

ExitProc=''
x=pos('/P:',ucargs)
if x>0 then do
  x1=pos('/P:"',ucargs)
  if x=x1 then do
    ExitProc=substr(args,x+4)
    x=pos('"',ExitProc)
    end
  else do
    ExitProc=substr(args,x+3)
    x=pos(' ',ExitProc)
    end
  if x>0 then ExitProc=substr(ExitProc,1,x-1)
  end
if ExitProc='#' then ExitProc=''

/* NEW on 11/18/01 */
delay=4
x=pos('/LW:',ucargs)
if x>0 then do
  delay=substr(ucargs,x+4,pos(' ',ucargs,x+4)-x-4)
  if verify(delay,'0123456789')>0 then delay=4
  end

lname=''
x=pos('/L:',ucargs)
if x>0 then do
  x1=pos('/L:"',ucargs)
  if x=x1 then do
    lname=substr(args,x+4)
    x=pos('"',lname)
    end
  else do
    lname=substr(args,x+3)
    x=pos(' ',lname)
    end
  if x>0 then lname=substr(lname,1,x-1)
  end
/* END NEW */

monitor=0
if ExitProc='' then monitor=3
if pos('/L',ucargs)>0 then do
  if monitor\=3 then monitor=2
  if backon=1 then monitor=1
  end

if monitor>0 then do
  monargs=substr(monargs,pos('" ',monargs)+2)
  if pos('/C',monargs)>0 then monargs=substr(monargs,1,pos('/C',monargs)-1)||substr(monargs,pos('/C',monargs)+3)
  if pos('/K',monargs)>0 then monargs=substr(monargs,1,pos('/K',monargs)-1)||substr(monargs,pos('/K',monargs)+3)
  if pos('/N',monargs)>0 then monargs=substr(monargs,1,pos('/N',monargs)-1)||substr(monargs,pos('/N',monargs)+3)
  monargs=strip(monargs)
  end

quot=""""
dr=''
dirs=''
dirs1=''
fn=''
pause=1
c='0D0A'x
verify=''

Command=strip(Command) /* Strip leading+trailing spaces */
TmpCmnd=Command


x=pos('CALL ',translate(TmpCmnd)) /* Get drive/dir/filename of Command */
if x=1 then TmpCmnd=substr(TmpCmnd,x+5)
x=pos(' ',TmpCmnd)
if x>0 then TmpCmnd=substr(TmpCmnd,1,x-1)
if TmpCmnd='' then call Help

object=0 /* Is "Command" an <objectID>? 0=No 1=Yes */
x=pos('<',TmpCmnd)
x1=pos('>',TmpCmnd)
if x=1&x1=length(TmpCmnd) then object=1

if object=0 then do /* Set drive/dir/filename if command */
  if pos('/',TmpCmnd)=0 then verify=stream(TmpCmnd,'C','query exists')
  if Verify\='' then do
    dr=filespec("drive",TmpCmnd)
    dirs=filespec("path",TmpCmnd)
    dirs1=dirs
    if length(dirs)>3 then dirs1=left(dirs,length(dirs)-1)
    fn=filespec("name",TmpCmnd)
    end
  end

if object=1 then do /* Open object */
  l=''
  call Pass1
  rc=SysOpenObject(TmpCmnd,0,1)
  if rc=1 then do
    call Pass2
    end
  else do
/* If OPEN fails */
    say "Open failed:  "||TmpCmnd
    say "Hit key to quit..."
    call SysGetKey 'noecho'
    pause=2
    end
  end

if object=0 then do /* Execute command */
  if dr\='' then dr
  if dirs1\='' then 'cd' dirs1
  if monitor>1 then call Pass1
  rc=0
  if rexxon=1&fn\=RUNCMD.CMD then interpret Command /* If Rexx... */
  else do
    /* Otherwise launch Program */
    if monitor>0 then select
      when pos('START ',translate(command))>0 then command
      when pos('CALL ',translate(command))>0 then 'start /C' monargs command
      otherwise
        'start /N' monargs command
        end
    else Command
    end
  if rc>1&rc\=255 then do
    say
    say '	Exit code: '||fn
    call charout ,'	>>RC='||rc||'<<	Hit any key to continue . . . '
    call SysGetKey 'noecho'
    pause=2
    say
    say
    end
  else do
    if monitor>1&backon=0 then do
      call Pass2
      end
    end
  if fn=RUNCMD.CMD then call SysFileDelete TmpCmnd
  end

Continue:
signal on halt name AB
if object=1&backon=0&l\=''|monitor=2 then call Mon

x1=pos('/C',ucargs)
if hold=1&pause=1&object=0 then call HoldOn /* Don't pause twice */

AB:
rc=rxqueue("delete","SWO2")
if rc\=0 then do
/* if ExitProc\=''&backon=0 then do */
  if ExitProc\='' then do
    j=0; a=0
    call SysQuerySwitchList "list."
    do i=1 to list.0
      if pos(sessname,list.i)<1 then do
        a=a+1
        nosess.a=list.i
        end
      if case=0 then do
        if pos(translate(ExitProc),translate(list.i))>0&pos(sessname,list.i)<1 then do /* Case INsensitive */
          j=j+1
          hit.j=list.i
          end
        end
      else do
        if pos(ExitProc,list.i)>0&pos(sessname,list.i)<1 then do /* Case SeNsItIvE */
          j=j+1
          hit.j=list.i
          end
        end
      end
    if j=0 then do
      call SysCls
      say 'Exit process "'ExitProc'" not found'
      call Pass3
      end
    if j>1 then do
      call SysCls
      do i=1 to list.0
        if list.i=sessname then do
          call SysSwitchSession list.i
          end
        end
      say 'Multiple "*'ExitProc'*" exit processes found:'
      k=0;lin=0
      do until k=j
        k=k+1;lin=lin+1
        call Charout,'  '||k||': '
        if pos(c,hit.k)>0 then do
          x=hit.k
          call Remcr
          end
        else say hit.k
        if lin=22 then call Pause
        end
      call Charout ,"Pick process 1-"||j||", otherwise display Tasklist: "
      u=''
      do until u*10>j|length(u)=0|u=0
        k=SysGetKey()
        if c2d(k)=13 then leave
        u=u||k
        if c2d(k)=27|verify(k,'0123456789')>0 then u=0
        end
      say
      if c2d(k)\=27 then do
        if u>j|length(u)=0|u=0 then do
          call SysCls
          call Pass3
          end
        else call SysSwitchSession hit.u
        end
      end
      call SysSleep .05
    if j=1 then do
      call SysSwitchSession hit.1
      end
    end
  end
if x1=0&object=0 then call directory currdir
call SysFileDelete IniFile /* Destroy O2.INI */
exit

return

SYNTAX:
  say 'Syntax error detected in user input'
  say 'REXX error' rc 'in line' sigl':' "ERRORTEXT"(rc)
  say "SOURCELINE"(sigl)
  trace ?r; nop
  call charout ,'-- Hit any key to switch to 'quot||ExitProc||quot
  call charout ,' --'
  call SysGetKey 'noecho'
  call AB
RETURN

HOLDON:
  call charout ,'-- Hit any key to switch to 'quot||ExitProc||quot
  if x1>0 then call charout ,' (and kill this process)'
  call charout ,' --'
  call SysGetKey 'noecho'
RETURN

PASS1:
  call SysQuerySwitchList "list.",D
  do i=1 to list.0
    old.i=list.i
    end
  x=list.0
RETURN

PASS2: /* Focus on newest added proc */
  a=0
  do until y=0|a=delay
    a=a+1
    call SysSleep 1
    call SysQuerySwitchList "list.",D
    do j=1 to list.0
      y=0
/* NEW 11/18/01 */
      if pos(lname,list.j)>0 then do
        l=subword(list.j,6)
        call SysSwitchSession l
        return
        end
/* END NEW */
      do k=1 to x
        if old.k=list.j then y=1
        end
      if y=0 then do
        if l='' then l=subword(list.j,6)
        call SysSwitchSession l
        end
      end
    end
RETURN

PASS3:
  do i=1 to list.0
    if list.i=sessname then do
      call SysSwitchSession list.i
      end
    end
  call Charout ,'1B'x'[1;37;40m'||'Tasklist:'
  say '1B'x'[0;37;40m'
  k=0;lin=0
  do until k=a
    k=k+1;lin=lin+1
    call Charout,'  '||k||': '
    if pos(c,nosess.k)>0 then do
      x=nosess.k
      call Remcr
      end
    else say nosess.k
    if lin=22 then call Pause
    end
  call Charout ,"Pick process 1-"||a||", otherwise display Desktop: "
  u=''
  do until u*10>a|length(u)=0|u=0
    k=SysGetKey()
    if c2d(k)=13 then leave
    u=u||k
    if c2d(k)=27|verify(k,'0123456789')>0 then u=0
    end
  say
  if u>list.0|length(u)=0|u=0 then do
    call SysSwitchSession 'Desktop'
    exit
    end
  call SysSwitchSession nosess.u
RETURN

MON:
  say 'Monitoring persistence of process "*'l'*"; Ctrl-C aborts...'
  do forever
    call SysSleep 1
    call SysQuerySwitchList "list."
    y=0
    do i=1 to list.0
/*  Is app still alive? */
      if pos(l,list.i)>0&pos(comsp,list.i)=0 then y=1
      end
    if y=0 then leave
    end
RETURN

PAUSE:
  call Charout,'1B'x'[1;37;40m'||'Hit a key to continue'
  call Charout,'1B'x'[0;37;40m'
  call SysGetKey 'noecho'
  say
  lin=0
RETURN

REMCR:
  do until pos(c,x)=0
    x=substr(x,1,pos(c,x)-1)||' '||substr(x,pos(c,x)+2)
    end
  say x
RETURN

HELP:
  say
  say 'O2.CMD v2.1 [XYOS2SHL.ZIP]  R.J.Holmgren  6/3/96 Rev.5/20/02'
  say 'Execute|Open OS/2 commands|objects from XyWrite Word Processor'
  say
  say 'O2.CMD is initiated by XYWWWEB.U2 frame "o2";'
  call Charout ,'  O2.CMD is '
  call Charout ,'1B'x'[1;37;40m'||'not run directly from the OS/2 command line'
  say '1B'x'[0;37;40m'||'!'
  say 'For Help, command "o2<Helpkey>" in XyWrite, and consult XYOS2SHL.DOC.'
  exit
RETURN
