/****
 SW.CMD v2.0 == SWitch.CMD (REXX) for OS/2 [XYOS2SHL.ZIP]
 SWitch focus between running OS/2 [DOS|WIN3x] processes
 SW.CMD v2.0 requires RexxUtil.DLL version 2.00+
 R.J.Holmgren  Freeware  6/3/96 Rev.8/1/00 PW273DIRM273DI

 Usage:   sw.cmd process name mask [/c]
            spaces permitted in process name mask (quotes not required)
            optional argument "/c" attempts to terminate (EXIT)
              the parent process after focus is SWitched
            special process name "*" = Display complete Tasklist

****/

/* Hard-Coded "Case" User Variable:
Process Name Case SeNsItIvE(=1) or INsensitive(=0,Default) ? */
case=0

'@echo off'

if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
if RxFuncQuery("SysQuerySwitchList")=1 then do
  say 'SW.CMD v2.0 requires RexxUtil.DLL version 2.00+'
  call Help
  end

call SysSetPriority 2,15
call rxqueue "delete","SWO2"
signal on Halt

alias=''
swtitle=''
quit='no'

parse arg alias
alias=strip(alias)

trn=translate(alias)
if trn='?'|trn='/?'|trn='-?'|trn='-HELP'|trn='HELP' then call Help

if trn='/C'|pos('/C',trn)=length(trn)-1 then do
  exuent=pos('/C',trn)
  if trn='/C'|exuent>0 then do
    if exuent>0 then alias=substr(alias,1,exuent-1)
    alias=strip(alias)
    quit='yes'
    end
  end

select
/*  Example User Aliases ͻ
    Enter aliases (synonyms) in following form (examples):         
     when alias='' then nop  /* display TaskList */                
                   below: show TaskList, KILL process]             
     when alias='q' then do; alias=''; quit='yes'; end             
     when alias='' then swtitle='XyWrite'                          
     when alias='ed' then swtitle='editor.exe'                     
     when alias='y' then do; swtitle='XyWrite'; quit='yes'; end    
     when alias='w' then swtitle='XyWin'                           
     when alias='d' then swtitle='Desktop'                         
     when alias='f' then swtitle='FullScreen OS/2 Command Session' 
     when alias='p' then swtitle='Post Road Mailer'                
     when alias='f f' then swtitle='FaxWorks Fax Win'              
                                                                   
    One alias per line.  Add new lines as necessary.               
    Aliases are case SeNsItIvE!                                    
    Enter your personal aliases BELOW using WHEN...THEN format:  
    ---------- DO  NOT  WRITE  ABOVE  THIS  LINE! -----------  */
  when alias='x' then swtitle='XyW'
  
  
/*              END  OF  USER-ALIAS  ENTRY  SPACE              
   ͼ */

when alias='*' then swtitle=''
otherwise
  swtitle=alias
  end

c='0D'x||'0A'x
j=0
agin:
if swtitle\='' then do
  call SysQuerySwitchList "list."
  do i=1 to list.0
    if case=0 then do
/* ExitProc INsensitive Case=0 */
      if pos(translate(swtitle),translate(list.i))>0 then do
        j=j+1
        hit.j=list.i
        end
      end
    else do
/* ExitProc SeNsItIvE Case=1 */
      if pos(swtitle,list.i)>0 then do
        j=j+1
        hit.j=list.i
        end
      end
    end

/* Put SW.CMD in foreground if display list, otherwise background OK */
  if j\=1 then do i=1 to list.0
    if translate(list.i)="SW.CMD" then do
      call SysSwitchSession list.i
      end
    end

  if j>1 then do
    say 'Multiple "*'swtitle'*" processes found:'
    k=0;lin=0
    do until k=j
      k=k+1;lin=lin+1
      call Charout,'  '||k||': '
      if pos(c,hit.k)>0 then do
        x=hit.k
        call Remcr
        end
      else say hit.k
      if lin=22 then call Pause
      end
    call Charout ,"Pick process 1-"||j||", otherwise display Tasklist: "
    call Getit
    if c2d(k)=27 then signal ab
    if y>j|length(y)=0|y=0 then do
      j=-1  /* Don't Switch to SW.CMD twice */
      swtitle=''
      call SysCls
      signal agin
      end
    else call SysSwitchSession hit.y
    end
  if j=1 then do
/* Doesn't always focus with just one call; error RC unreliable! */
    call SysSwitchSession hit.j
    call SysSwitchSession hit.j
    end
  if j=0 then do
    say 'Process "'swtitle'" not found'
    j=-1
    swtitle=''
    signal agin
    end
  end
else do
  call Task
  call SysQuerySwitchList "list."
  if j>-1 then do i=1 to list.0
    if translate(list.i)="SW.CMD" then do
      call SysSwitchSession list.i
      end
    end
  j=0;lin=0
  do i=1 to list.0
    if translate(list.i)\="SW.CMD" then do
      j=j+1;lin=lin+1
      hit.j=list.i
      call Charout,'  '||j||': '
      if pos(c,hit.j)>0 then do
        x=list.i
        call Remcr
        end
      else say hit.j
      end
    if lin=22 then call Pause
    end
  call Charout ,"Pick process 1-"||j||", otherwise Abort: "
  call Getit
  if y>j|length(y)=0|y=0 then do
    ab:
    say 'Abort'
    signal bye
    end
  else call SysSwitchSession hit.y
  end

BYE:
  quit=translate(quit)
  if quit='YES' then do
    call rxqueue "create","SWO2"
    'exit'
    end
  exit
RETURN

GETIT:
  y=''
  do until y*10>j|length(y)=0|y=0
    k=SysGetKey()
    if c2d(k)=13 then leave
    y=y||k
    if c2d(k)=27|verify(k,'0123456789')>0 then y=0
    end
  say
RETURN

HALT:
  signal ab
RETURN

TASK:
  call Charout ,'1B'x'[1;37;40m'||'Tasklist:'
  say '1B'x'[0;37;40m'
RETURN

PAUSE:
  call Charout,'1B'x'[1;37;40m'||'Hit a key to continue'
  call Charout,'1B'x'[0;37;40m'
  call SysGetKey 'noecho'
  say
  lin=0
RETURN

REMCR:
  do until pos(c,x)=0
    x=substr(x,1,pos(c,x)-1)||' '||substr(x,pos(c,x)+2)
    end
  say x
RETURN

HELP:
  say
  say 'SW.CMD v2.0 [XYOS2SHL.ZIP]  R.J.Holmgren  6/3/96 Rev.5/23/00'
  say 'SWitch focus between already-running processes,'
  say '	from OS/2 or DOS command lines'
  say
  say 'Usage:	SW [process name mask] [/C]'
  say '	process name = title in Ctrl-Esc Tasklist'
  say '	/C terminates calling command line process after focus is SWitched'
  say '	special process name "*" = Display Tasklist'
  exit
RETURN

