/* GETHTTP.CMD Fetch any HTTP:// page or file to current directory
Syntax: [REXX.EXE] GETHTTP.CMD remote_URL [local_filename]
On Exit, total bytes received is written to Rexx "QUEUE:"
RJH 7/16/01 RFC1945 */

parse arg url
url=strip(url)
if pos('"',url)=1&lastpos('"',url)=length(url) then url=strip(substr(url,2,length(url)-2))
if pos('HTTP://',translate(url))=1 then url=substr(url,8)
file2=''
parse var url url'/'file' 'file2
if file2\='' then fn=file2
else fn=file
if pos('/',fn)>0 then fn=substr(fn,lastpos('/',fn)+1)
if length(directory())>3 then fn=directory()||'\'||fn
else fn=directory()||fn
rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
rxsck=RxFuncQuery("SockLoadFuncs")
if rxsck then do
  call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
  call SockLoadFuncs
  call SysCls
  end
crlf='0D0A0D0A'x
snd='GET /'||file||' HTTP/1.0'||crlf /* Normal format */
say
Full:
socket=SockSocket('AF_INET','SOCK_STREAM',0)
if socket>-1 then do
  rc=SockGetHostByName(url,'host.!')
  host.!family='AF_INET'
  host.!port=80
  rc=SockConnect(socket,'host.!')
  if rc=0 then do
    rc=SockSend(socket,snd)
    if rc>-1 then do
      first=''
      do until pos(crlf,sockdata)>0|rc=0
        rc=SockRecv(socket,'sockdata',1024)
        if first='' then first=left(sockdata,pos('0D0A'x,sockdata)-1)
        end
      if rc=0|pos('200 OK',first)=0 then do
        if rc>0&pos('404',first)>0&pos('http://',snd)=0 then do
          do until rc=0
            rc=SockRecv(socket,'sockdata',1024)
            end
          call SockShutDown socket,2
          call SockClose socket
          snd='GET http://'||url||'/'||file||' HTTP/1.0'||crlf /* AceDSL requires this format! */
          signal Full
          end
        else do
          call SockShutDown socket,2
          call SockClose socket
          if rxsck then call SockDropFuncs
          if rxutl then call RxFuncDrop 'SysLoadFuncs'
          say 'File "/'file'" not found'
          exit
          end
        end
      say 'Filing "http://'url'/'file'" as "'fn'"'
      sockdata=substr(sockdata,pos(crlf,sockdata)+4)
      call stream fn,'C','open write'
      call charout fn,sockdata
      bytes=0
      call Charout,'Bytes received: '
      clr=SysCurPos()
      r=pos(' ',clr)
      l=left(clr,r-1)
      r=right(clr,length(clr)-r)
      bytes=bytes+length(sockdata)
      call Charout,bytes
      do until rc=0
        rc=SockRecv(socket,'sockdata',1024)
        call charout fn,sockdata
        bytes=bytes+rc
        call SysCurPos l,r
        call Charout,bytes
        end
      say ' ...Done'
      call stream fn,'C','close'
      call lineout 'QUEUE:',bytes
      end
    end
  end
call SockShutDown socket,2
call SockClose socket
if rxsck then call SockDropFuncs
if rxutl then call RxFuncDrop 'SysLoadFuncs'
exit
