/* Get News with Rexx  RJH 2/4/01
http://sasun4.epfl.ch/News/Document/RFC977.html */

/* BEGIN USER VARIABLES: */
nntp='160.79.54.12'  /* NNTP Server */
newsfile='nntp.tmp'  /* Local News File [d:\path\]filename */
nport=119   /* NNTP Port */
/* END USER VARIABLES */

rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
rxsck=RxFuncQuery("SockLoadFuncs")
if rxsck then do
  call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
  call SockLoadFuncs
  call SysCls
  end
signal on halt name Bye
ng=''
newsfile=translate(newsfile)
if pos('\',newsfile)=0 then do
  if length(directory())>3 then newsfile=directory()||'\'||newsfile
  else newsfile=directory()||newsfile
  end
if stream(newsfile,'C','query exists')\='' then call SysFileDelete newsfile
call stream newsfile,'C','open'
say 'News from' sender 'via' nntp
say
socket=SockSocket('AF_INET','SOCK_STREAM','IPPROTO_TCP')
if socket>-1 then do
  if verify(nntp,'.0123456789')>0 then rc=SockGetHostByName(nntp,'host.!')
  else rc=SockGetHostByAddr(nntp,'host.!')
  if rc=1 then do
    host.!family='AF_INET'
    host.!port=nport
    rc=SockConnect(socket,'host.!')
    if rc=0 then do
      rc=SockRecv(socket,'sockdata',1024)
      call Edsock
      if pos('200',sockdata)=1|pos('201',sockdata)=1 then do
        crlf ='0D0A'x 
        do until k='Q'
          say
          call Charout,'File_all_groups Join_group Read Help Quit'
          do until pos(k,'FHJQR')>0
            k=translate(SysGetKey('noecho'))
            end
          say
          if k='F' then do
            sub='All Newsgroups'
            rc=SockSend(socket,'LIST'||crlf)
            if rc>-1 then do
              rc=SockRecv(socket,'sockdata',1024)
              if pos('215',sockdata)\=1 then call err
              else call Writeit
              end
            else call err2
            end
          if k='J' then do
            call Charout,'Join which newsgroup? '
            parse pull ng
            ng=translate(ng,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')
            rc=SockSend(socket,'GROUP 'ng||crlf)
            if rc>-1 then do
              rc=SockRecv(socket,'sockdata',1024)
              if pos('211',sockdata)\=1 then do
                say 'Newsgroup 'ng' does not exist on this server: 'left(sockdata,3)
                ng=''
                call err
                end
              else do
                parse var sockdata dummy' 'arts' 'beg' 'end ' 'rem
                say 'Messages available: 'arts
                lins=1
                do i=beg to end
                  rc=SockSend(socket,'STAT 'i||crlf)
                  call Verfy
                  if pos('223',sockdata)=1 then do
                    rc=SockSend(socket,'HEAD'||crlf)
                    call Verfy
                    if pos('221',sockdata)=1 then do
                      fr='';sb='';dt=''
                      do until right(sockdata,3)='.'||crlf
                        do until length(remainder)=0|pos(crlf,remainder)=0
                          parse var sockdata lin '0D0A'x remainder
                          if pos('From: ',lin)=1 then fr=substr(lin,7)
                          if pos('Subject: ',lin)=1 then sb=substr(lin,10)
                          if pos('Date: ',lin)=1 then dt=substr(lin,7)
                          sockdata=remainder
                          end
                        if length(remainder)>0 then call Charout remainder
                        if right(sockdata,3)\='.'||crlf then do
                          rc=SockRecv(socket,'sockdata',1024)
                          end
                        end
                      summ=i-beg+1': '
                      if sb\='' then summ=summ||sb||'|'
                      if fr\='' then summ=summ||fr||'|'
                      if dt\='' then summ=summ||dt
                      say summ
                      lins=lins+length(summ)%80+1
                      if lins>=23 then call Pause
                      end
                    else say 'Error: 'sockdata
                    end
                  else say 'Article 'i' no longer on this server: 'left(sockdata,3)
                  end
                end
              end
            else call err2
            end
          if k='R'&ng\='' then do
            do until y<=end&y>=beg
              do until verify(y,'0123456789')=0
                call Charout,'Read which article (by number)? '
                parse pull y
                say
                end
              y=y+beg-1
              end
            call SockSend socket,'STAT 'y||crlf
            call SockRecv socket,'sockdata',1024
            call SockSend socket,'BODY'||crlf
            call Verfy
            if pos('222',sockdata)=1 then call Readit
            end
          else if k='R' then do
            say 'No Newsgroup selected'
            call err
            end
          end
        end
      else call err
      end
    else call err2
    end
  else call err2
  end
bye:
rc=SockSend(socket,'QUIT'||crlf)
rc=SockRecv(socket,'sockdata',1024)
say
call Charout,'QUITting: 'rc
/* call SockShutDown socket,2 -- Bombs in Windows! They forgot to put function in DLL, despite being documented */
call SockClose socket
bye2:
call stream newsfile,'C','close'
bye3:
if rxsck then call SockDropFuncs
if rxutl then call SysDropFuncs
exit

ERR:
  say 'NNTP Error - Aborting'
  call Bye
RETURN

ERR2:
  say 'Socket Error - Aborting'
  call Bye
RETURN

EDSOCK:
  sockdata=left(sockdata,length(sockdata)-2)
  say sockdata
RETURN

WRITEIT:
  say 'Writing 'sub' to 'newsfile'...'
  remainder=sockdata
  do until right(sockdata,3)='.'||crlf
    rc=SockRecv(socket,'sockdata',1024)
    if remainder\='' then do
      sockdata=remainder||sockdata
      remainder=''
      end
    call charout newsfile,sockdata
    end
RETURN

READIT:
  call SysCls
  lins=0
  remainder=sockdata
  if rc>-1 then do until lin='.'
    if right(sockdata,3)\='.'||crlf then do
      rc=SockRecv(socket,'sockdata',1024)
      sockdata=remainder||sockdata
      end
    do until length(remainder)=0
      parse var sockdata lin '0D0A'x remainder
      say lin
      lins=lins+1
      if k\='L'&lins=23 then call Pause
      sockdata=remainder
      end
    end
  say
RETURN

PAUSE:
  call Charout,'Hit a key to continue'
  call SysGetKey 'noecho'
  say
  lins=0
  call SysCls
RETURN

VERFY:
  do until verify(left(sockdata,3),'0123456789')=0
    rc=SockRecv(socket,'sockdata',1024)
    end
RETURN

