/* PRUNE.CMD  RJH 2/8/02
Delete all files in Directory Before[After] Date */

rxutl=0
signal on Halt
dr='';dy='';dm='';dd='';ba=''
parse arg '"'dr'" 'dy'-'dm'-'dd' 'ba
dy=strip(dy)
dm=strip(dm)
dd=strip(dd)
ba=translate(strip(ba))
if ba\='A' then ba='B'
if dr=''|length(dy)\=4|length(dm)\=2|length(dd)\=2|verify(dy,'0123456789')>0|verify(dm,'0123456789')>0|verify(dd,'0123456789')>0 then call Help
orgdir=directory()
if right(dr,1)='\'&length(dr)>4 then dr=left(dr,length(dr)-1)
rc=directory(dr)
if (pos('.',dr)<1&pos('\',dr)<1)|rc\=directory() then do
  say 'ERROR: Directory "'dr'" not found'
  call Help
  end
rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
d=dy||dm||dd
call SysFileTree dr||"\*","file","FL"
do i=1 to file.0
  parse var file.i dfy'-'dfm'-'dfd' 'time' 'bal
  bal=strip(bal)
  parse var bal size' 'bal
  bal=strip(bal)
  parse var bal attribs' 'fl
  fl=strip(fl)
  df=dfy||dfm||dfd
  del=0
  if ba='B'&df<d then del=1
  if ba='A'&d<df then del=1
  if del=1 then do
    call SysFileTree fl,"fil","F",,'-----'
    rc=SysFileDelete(fl)
    if rc=0 then say 'Deleted' fl ' ['dfy'-'dfm'-'dfd']'
    else say 'Error deleting' fl': return code='rc
    end
  end
Halt:
if rxutl then call SysDropFuncs
exit

HELP:
  say
  say 'PRUNE.CMD for Win32|OS/2  RJH 10/17/01 Requires IBM [Object] Rexx'
  say 'Delete all files in Directory Before[After] Date'
  say
  say 'Syntax: [REXX.EXE] PRUNE.CMD "directory_to_prune" yyyy-mm-dd [B|a]'
  say "  where 'B'=Before [default]|'A'=After date supplied"
  say '  e.g. REXX.EXE PRUNE.CMD "c:\new" 2000-12-21 a'
  say '       PRUNE "." 2000-12-21'
  say
  say 'Note Well:  PRUNE is a DANGEROUS command! Deletions proceed without'
  say 'confirmation. Read-Only|Hidden|System files ARE deleted!'
  say 'Ctrl-C to Abort (if supported by Operating System)'
  exit
RETURN
