/* Simple Send Mail with Object Rexx  RJH LastRev.6/28/02  RCF 821

Command:
[REXX.EXE] [d:\path\]SENDMAIL.CMD [To] [Subject]
e.g. "sendmail.cmd somebody@somewhere.net Message about something<cr>"
Command line arguments override hard-coded variables (below)

  If command-line arguments "To" and "Subject" are
  provided, the mailfile contains only message text.

  If command-line arguments "To" and "Subject" are NOT provided,
  To and Subject are assumed to be included within the message
  (mailfile), on the FIRST TWO LINES, in format:
To: recipient@domain
Subject: Blah blah blah

If "sentfile" mask is specified, a copy of mailfile is archived in
indicated directory as "ymmddnnn" (where "nnn" begins at "001" and is
incremented as necessary), plus the indicated EXTension, e.g.
sentfile='G:\XY4\SENT\?.POP' generates "G:\XY4\SENT\20511003.POP" for the
third archived msg on 11 May 2002 (max. archived msgs/day=999). To omit
"sentfile" archiving, specify "sentfile=''". The archive directory MUST
exist!

   BEGIN USER VARIABLES: */
smtp='smtp.myserver.com'  /* SMTP Server */
sender='myusername@mydomain.com'  /* Your Email address */
from='Full Name <myusername@mydomain.com>'  /* "From" ID */
mailfile='smtp.tmp'  /* Local Outgoing Mail File [d:\path\]filename -- always use the SAME filename! */
sentfile=''  /* Local Archive Filemask d:\path\?.EXT */
sport=25   /* SMTP Port */
/* END USER VARIABLES */


rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
rxsck=RxFuncQuery("SockLoadFuncs")
if rxsck then do
  call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
  call SockLoadFuncs
  call SysCls
  end
sf=0
subject=''
sentfn='///'
parse arg to' 'subject
noto=0
if to='' then noto=1
mailfile=translate(mailfile)
if pos('\',mailfile)=0 then do
  if length(directory())>3 then mailfile=directory()||'\'||mailfile
  else mailfile=directory()||mailfile
  end
if stream(mailfile,'C','query exists')='' then do
  say 'No mailfile 'mailfile' exists'
  call Bye3
  end
call stream mailfile,'C','open read'
if noto then do
  if lines\=0 then to=linein(mailfile)
  if pos('TO: ',translate(to))\=1|length(to)<5 then to=''
  if to\='' then do
    if lines\=0 then subject=linein(mailfile)
    if pos('SUBJECT: ',translate(subject))\=1|length(subject)<10 then subject=''
    end
  if to\=''&subject\='' then do
    to=right(to,length(to)-4)
    subject=right(subject,length(subject)-9)
    end
  end
if to=''|subject=''|pos('@',to)<2|pos('.',to)=0 then do
  say 'No (or bad) "To: " and/or "Subject: " provided - Aborting'
  say 'To: "'to'"'
  say 'Subject: "'subject'"'
  call Bye2
  end
if sentfile\='' then do
  if pos('\?.',sentfile)>0 then do
    rc=SysFileTree(left(sentfile,pos('\?.',sentfile)-1),'dir','D')
    if rc\=0|dir.0=0 then do
      say 'Sentfile directory "'||left(sentfile,pos('\?.',sentfile)-1)||'" not found - no copy of mail archived'
      call Go
      end
/* Template for incrementing to nonexistent 'sentfile' name(number) */
    dw=0
    do until stream(sentfn,'C','query exists')=''
      dw=dw+1
      if dw=1000 then do
        say 'Cannot archive more than 999 msgs daily'
        call Go
        end
      sentfn=left(sentfile,pos('?.',sentfile)-1)||substr(date('S'),4)||right(dw,3,'0')||substr(sentfile,pos('?.',sentfile)+1)
      end
    call stream sentfn,'C','open write'
    sf=1
    end
  else say 'Bad sentfile template - no copy of mail archived'
  end
go:
say 'Sending mail from' sender 'via' smtp
say
socket=SockSocket('AF_INET','SOCK_STREAM','IPPROTO_TCP')
if socket>-1 then do
  if verify(smtp,'.0123456789')>0 then rc=SockGetHostByName(smtp,'host.!')
  else rc=SockGetHostByAddr(smtp,'host.!')
  if rc=1 then do
    host.!family='AF_INET'
    host.!port=sport
    rc=SockConnect(socket,'host.!')
    if rc=0 then do
      rc=SockRecv(socket,'sockdata',1024)
      call Edsock
      if pos('220',sockdata)\=1 then call err
      crlf ='0D0A'x
      rc=SockSend(socket,'HELO 'smtp||crlf)
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        call Edsock
        if pos('250',sockdata)\=1 then call err
        end
      else call err2
      rc=SockSend(socket,'MAIL FROM: 'sender||crlf)
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        call Edsock
        if pos('250',sockdata)\=1 then call err
        end
      else call err2
      rc=SockSend(socket,'RCPT TO: 'to||crlf)
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        call Edsock
        if pos('250',sockdata)\=1 then call err
        end
      else call err2
      call SockSend socket,'DATA'||crlf
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        call Edsock
        if pos('354',sockdata)\=1 then call err
        end
      else call err2
      txt='Reply-To: '||sender||crlf
      call Goout
      txt='X-Mailer: SendMail for XyWrite+XyShell/Rexx (R.J.Holmgren 28 June 2002)'||crlf
      call Goout
      txt='X-Discontent: The Duly-Selected Resident'||crlf
      call Goout
      tzorg=translate(value('TZ',,'ENVIRONMENT'))
      /* tzorg='sssndddn-1,M4.1.0/02:00:00,M10.5.0/02:00:00' */ /* Worldwide Default Dates/Time for DST; following routine does not accept Julian dates! */
      parse var tzorg tz','db'/'dbt','de'/'det
      if db\=''&de='' then parse var tzorg tz','db','de
      if tz='' then tz='UTC0'
      if db='' then db='M4.1.0'
      parse var db dbm'.'dbn'.'dbd
      dbd=dbd-1;if dbd<0 then dbd=6
      if dbt='' then dbt='02:00:00'
      dbt=time('S',dbt)
      if de='' then de='M10.5.0'
      parse var de dem'.'den'.'ded
      ded=ded-1;if ded<0 then ded=6
      if det='' then det='02:00:00'
      det=time('S',det)
      yr=left(date('S'),4)
      dbm=right(substr(dbm,2),2,'0')
      dem=right(substr(dem,2),2,'0')
      dbl=31;if pos(dbm,'04 06 09 11')>0 then dbl=30;if dbm='02' then do;if yr//4=0 then dbl=29;else dbl=28;end
      del=31;if pos(dem,'04 06 09 11')>0 then del=30;if dem='02' then do;if yr//4=0 then del=29;else del=28;end
      bday=right((dbd-date('B',yr||dbm||'01','S')//7)+(dbn-1)*7+1,2,'0')
      if bday<1 then bday=right(bday+7,2,'0')
      if bday>dbl then bday=right(bday-7,2,'0')
      eday=right((ded-date('B',yr||dem||'01','S')//7)+(den-1)*7+1,2,'0')
      if eday<1 then eday=right(eday+7,2,'0')
      if eday>del then eday=right(eday-7,2,'0')
      today=date('S')||'.'||time('S')
      dbeg=yr||dbm||bday||'.'||dbt
      dend=yr||dem||eday||'.'||det
      if today<dbeg|today>dend then today='S'
      else today='D'
      dum=verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
      tzstr=left(tz,dum-1)
      tz=substr(tz,dum)
      tzhh=tz
      dum=verify(tz,'1234567890+-:')
      if dum>0 then tzhh=left(tz,dum-1)
      if today='D'&dum>1 then do
        tz=substr(tz,dum)
        dum=verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
        if dum=0 then tzstr=tz
        else tzstr=left(tz,dum-1)
        if dum>0 then do
          tz=substr(tz,dum)
          tzhh=tz
          end
        end
      tzmm='00'
      if pos(':',tzhh)>1 then do
        tzmm=substr(tzhh,pos(':',tzhh)+1)
        tzhh=left(tzhh,pos(':',tzhh)-1)
        end
      if pos(':',tzmm)>1 then tzmm=left(tzmm,pos(':',tzmm)-1)
      if today='D'&verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')=0 then tzhh=tzhh-1
      tzs='+'
      if tzhh>0 then tzs='-'
      tzhh=right(abs(tzhh),2,'0')
      txt='Date: '||left(date('W'),3)||', 'date()||' '||time()||' '||tzs||tzhh||tzmm||' ('||tzstr||')'||crlf
      call Goout
      txt='From: '||from||crlf
      call Goout
      txt='To: '||to||crlf
      call Goout
      txt='Subject: '||subject||crlf
      call Goout
      txt=''||crlf
      call Goout
      do while lines(mailfile)\=0
        x=linein(mailfile)
        if pos('.',x)=1 then x='.'||x
        call SockSend socket,x||crlf
        if sf then call charout sentfn,x||crlf
        end
      rc=SockSend(socket,crlf||'.'||crlf)
      if rc>-1 then do
        rc=SockRecv(socket,'sockdata',1024)
        call Edsock
        if pos('250',sockdata)\=1 then call err
        end
      else call err2
      end
    else call err2
    end
  else call err2
  end
bye:
rc=SockSend(socket,'QUIT'||crlf)
rc=SockRecv(socket,'sockdata',1024)
/* call SockShutDown socket,2 -- Bombs in Windows! They forgot to put function in DLL, despite being documented */
call SockClose socket
bye2:
if stream(sentfn,'C','query exists')\='' then do
  call stream sentfn,'C','close'
  if sf=0 then call SysFileDelete sentfn
  end
call stream mailfile,'C','close'
bye3:
if rxsck then call SockDropFuncs
if sf then say 'Mailfile archived as' sentfn
say
call Charout,'QUITting: '
if rxutl then call SysDropFuncs
exit

ERR:
  say 'SMTP Error - Aborting'
  sf=0
  call Bye
RETURN

ERR2:
  say 'Socket Error - Aborting'
  sf=0
  call Bye
RETURN

GOOUT:
  call SockSend socket,txt
  if sf then call charout sentfn,txt
RETURN

EDSOCK:
  sockdata=left(sockdata,length(sockdata)-2)
  say sockdata
RETURN

AGIN:
  tz=substr(tz,verify(translate(tz),'ABCDEFGHIJKLMNOPQRSTUVWXYZ'))
  tzhh=tz
  if verify(tz,'1234567890+-:')>0 then tzhh=left(tz,verify(tz,'1234567890+-:')-1)
  tzdt=''
  if verify(tz,'1234567890+-:')>0 then tzdt=substr(tz,verify(tz,'1234567890+-:'))
  if today='D'&tzdt\='' then do
    if verify(translate(tzdt),'ABCDEFGHIJKLMNOPQRSTUVWXYZ')>0 then do
      tz=tzdt
      today=''
      call Agin
      end
    else tzhh=tzhh-1
    end
  tzmm=substr(tzhh,verify(tzhh,'0123456789+-')+1)
  if tzmm=tzhh then tzmm='00'
  tzhh=substr(tzhh,1,length(tzhh)-verify(tzhh,'0123456789+-'))
  tzs='+'
  if tzhh>0 then tzs='-'
  tzhh=right(abs(tzhh),2,'0')
  tz=tzs||tzhh||tzmm
RETURN

