/* SETTIME.CMD  Auto-Calibrate System Time with U.S. Government Cesium Clock  RJH  4/8/02 */

signal on Halt
rxutl=RxFuncQuery("SysLoadFuncs")
if rxutl then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
if tzorg='?'|tzorg='/?'|tzorg='-?'|tzorg='-HELP'|tzorg='HELP' then call Help
rxsck=RxFuncQuery("SockLoadFuncs")
if rxsck then do
  call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
  call SockLoadFuncs
  call SysCls
  end
'@echo off'
call SysCurState 'off'
parse arg tzorg
if tzorg='' then tzorg=value('TZ',,'ENVIRONMENT')
/* Worldwide Default Dates/Time for DST */
/* tzorg='EST+05:00:00EDT+04:00:00,M4.1.0/02:00:00,M10.5.0/02:00:00' */
parse var tzorg tz','db'/'dbt','de'/'det
if db\=''&de='' then parse var tzorg tz','db','de
tz=translate(tz)
if tz='' then tz='UTC0'
if db='' then db='M4.1.0'
parse var db dbm'.'dbn'.'dbd
dbd=dbd-1;if dbd<0 then dbd=6
if dbt='' then dbt='02:00:00'
dbt=right(time('S',dbt),5,'0')
if de='' then de='M10.5.0'
parse var de dem'.'den'.'ded
ded=ded-1;if ded<0 then ded=6
if det='' then det='02:00:00'
det=right(time('S',det),5,'0')
yr=left(date('S'),4)
dbm=right(substr(dbm,2),2,'0')  /* Dump 'M';Pad Months w/'0' */
dem=right(substr(dem,2),2,'0')
dbl=31;if pos(dbm,'04 06 09 11')>0 then dbl=30;if dbm='02' then do;if yr//4=0 then dbl=29;else dbl=28;end
del=31;if pos(dem,'04 06 09 11')>0 then del=30;if dem='02' then do;if yr//4=0 then del=29;else del=28;end
bday=right((dbd-date('B',yr||dbm||'01','S')//7)+(dbn-1)*7+1,2,'0')  /* Get 1st Day of ET==>DT Month */
if bday<1 then bday=right(bday+7,2,'0')
if bday>dbl then bday=right(bday-7,2,'0')
eday=right((ded-date('B',yr||dem||'01','S')//7)+(den-1)*7+1,2,'0')
if eday<1 then eday=right(eday+7,2,'0')
if eday>del then eday=right(eday-7,2,'0')
today=date('S')||'.'||time('S')
dbeg=yr||dbm||bday||'.'||dbt
dend=yr||dem||eday||'.'||det
if today<dbeg|today>dend then today='S'
else today='D'
tz=substr(tz,verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ'))
tzhh=tz
if verify(tz,'1234567890+-:')>0 then tzhh=left(tz,verify(tz,'1234567890+-:')-1)
if today='D'&verify(tz,'1234567890+-:')>1 then do
  tz=substr(tz,verify(tz,'1234567890+-:'))
  if verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')>0 then do
    tz=substr(tz,verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ'))
    tzhh=tz
    end
  end
tzmm='00'
tzss='00'
if pos(':',tzhh)>1 then do
  tzmm=substr(tzhh,pos(':',tzhh)+1)
  tzhh=left(tzhh,pos(':',tzhh)-1)
  end
if pos(':',tzmm)>1 then do
  tzss=substr(tzmm,pos(':',tzmm)+1)
  tzmm=left(tzmm,pos(':',tzmm)-1)
  end
if today='D'&verify(tz,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')=0 then tzhh=tzhh-1
tzs='+'
if tzhh>0 then tzs='-'
tz=tzs||abs(tzhh)
tzmm=tzs||tzmm
tzss=tzs||tzss
socket=SockSocket('AF_INET','SOCK_STREAM',0)
if socket>-1 then do
  host.!addr='132.163.4.101'
  host.!family='AF_INET'
  host.!port=13
  say 'Connecting to Server 132.163.4.101 (time-a.timefreq.bldrdoc.gov) Timeout=75 secs...'
  rc=SockConnect(socket,'host.!')
  if rc=0 then do
    char='0A'x
    change=0
    say 'Fetching Data...'
    x=SockRecv(socket,'sockdata',1024)||'~'||date('B')||'~'||time('N')
    parse value x with len '~' ldate '~' ltime
    if len>0 then do
      sockdata=strip(sockdata,,char)
      sockdata=strip(sockdata)
      parse value sockdata with mjd ' ' year '-' month '-' day ' ' hours ':' mins ':' secs ' 'dst ' ' leaps ' ' health ' '
      parse value ltime with lhours ':' lmins ':' lsecs
  /* 678575 days between Rexx 1-Jan-0 and NIST/UNIX 8-Jul-1889 calendars */
      mjd=mjd+678575
      hours=hours+tz
      mins=mins+tzmm
      secs=secs+tzss
      if secs>59 then do until secs<60
        secs=secs-60
        mins=mins+1
        end
      else if secs<0 then do until secs>=0
        secs=secs+60
        mins=mins-1
        end
      if mins>59 then do until mins<60
        mins=mins-60
        hours=hours+1
        end
      else if mins<0 then do until mins>=0
        mins=mins+60
        hours=hours-1
        end
      if hours>23 then do
        hours=hours-24
        mjd=mjd+1
        end
      else if hours<0 then do
        hours=hours+24
        mjd=mjd-1
        end
      if health=0 then do
        if mjd\=ldate then do
          'date' date('U',mjd,'B','-')
          change=1
          end
        hours=right(hours,2,'0')
        mins=right(mins,2,'0')
        secs=right(secs,2,'0')
        if hours\=lhours|mins\=lmins|secs\=lsecs then do
          'time' hours':'mins':'secs
          change=change+2
          end
        say
        say len 'bytes received: "'||sockdata||'"'
        if change>0 then do
          if change\=2 then call charout,'Adjusted date from' date('U',ldate,'B','-') 'to' date('U',mjd,'B','-')
          if change=3 then say
          if change>1 then call charout,'Adjusted time from' ltime 'to' hours':'mins':'secs
          numeric digits 12
          err=abs((86400*ldate+3600*lhours+60*lmins+lsecs)-(86400*mjd+3600*hours+60*mins+secs))
          call charout,'  (correction='err' second'
          if err>1 then call charout,'s'
          say ')'
          end
        else say 'No Date|Time adjustment necessary'
        call charout,'Now:  'date('W') date('L')' 'hours':'mins':'secs' ('
        if today='D' then call charout,'Daylight'
        else call charout,'Standard'
        say ' Time)'
        say 'TimeZone (TZ environment variable): 'tzorg
        say
        end
      else say 'NIST server declares itself "unhealthy"; no checks|adjustments made'
      end
    else say 'No data provided by server'
    end
  else say 'Connection to NIST on port 13 failed!'
  end
else say 'Socket creation error'

HALT:
call SockShutDown socket,2
call SockClose socket
call SysCurState 'on'
if rxsck then call SockDropFuncs
if rxutl then call SysDropFuncs
exit

HELP:
  say
  say 'SETTIME.CMD for Windows|OS/2  R.J.Holmgren  11/25/01'
  say 'Calibrate computer System Date+Time in Win32 or OS/2'
  say '  using National Institute of Standards and Technology'
  say '  Cesium Clock'
  say 'Corrections are automatic if NIST server is healthy'
  say 'Accurate to approximately 1 second'
  say 'Year-end leap seconds are ignored'
  say
  say 'In CONFIG.SYS (OS/2), or AUTOEXEC.BAT|AUTOEXEC.NT (Win32), SET'
  say '  environmental variable TZ to your local Time Zone relative to UTC'
  say '  (Universal Coordinated Time=Greenwich Mean Time), the international'
  say '  standard (UTC0=GMT0). The full TZ spec for Eastern Time (USA) is:'
  say 'SET TZ=EST+05:00:00EDT+04:00:00,M4.1.0/02:00:00,M10.5.0/02:00:00'
  say '  i.e. UTC is 5:00:00 hours ahead of local Standard time, UTC is 4:00:00'
  say '  hours ahead of local Daylight time, Daylight time begins in the 4th Month,'
  say '  1st week, on Day 0 (Sunday; cf. Saturday=Day 6) at 2:00:00 hours, Daylight'
  say '  time ends in the 10th Month, last (5th) week, on Day 0 at 2:00:00 hours'
  say
  'pause'
  call SysCls
  say 'Assumptions:'
  say 'If not stated, "M4.1.0/02:00:00,M10.5.0/02:00:00" is the international'
  say '  default for switching to and from Daylight Time. N.B.: Different dates'
  say '  apply in the Southern Hemisphere, e.g. for New South Wales (Australia):'
  say 'SET TZ=EET-10EETDT-11,M10.5.0/02:00:00,M3.5.0/02:00:00'
  say 'If Daylight Time is stated but the time difference is omitted, Daylight'
  say '  Time is 1 hour earlier relative to UTC. Therefore, Eastern Time is usually'
  say '  specified as:'
  say 'SET TZ=EST5EDT'
  say '  Compare Newfoundland:'
  say 'SET TZ=NST3:30NDT1:30'
  say 'If Daylight Time is not stated, Standard Time applies all year, e.g. in'
  say '  Honshu (central Japan):'
  say 'TZ=JST-9'
  say
  say 'Examples:'
  say 'Britain: SET TZ=WET0WETDST'
  say 'California: SET TZ=PST8PDT'
  say 'Illinois: SET TZ=CST6CDT'
  say 'Middle Europe: SET TZ=MET-2METDST'
  say
  'pause'
  call SysCls
  say 'Warning: TZ also accepts Julian dates, but this routine does not interpret'
  say 'them.'
  say
  say 'Requires IBM ObjectRexx for Win32|OS/2 [or, OS/2 only, IBM Classic Rexx'
  say '  as well as Rexx Sockets API (RXSOCK.DLL)]'
  say
  say 'Usage:	[Windows only: REXX.EXE] SETTIME.CMD [TZ]|[/?]'
  say
  if rxutl then call SysDropFuncs
  exit
RETURN
