/* XYFTP.CMD  [RJH] 5/25/02
Get remote file to current local d:\dir
Put local file on remote host
Delete remote file

Usages (3):
----------
1) Get_File:
   [REXX.EXE] XYFTP.CMD [username:password@]url[/subdirectories]/remote filename ["local filename"] [B|a]
2) Put_File:
   [REXX.EXE] XYFTP.CMD "local filename" [username:password@]url[/subdirectories][/remote filename] [B|a]
3) Delete_File:
   [REXX.EXE] XYFTP.CMD [username:password@]url[/subdirectories]/remote filename D

  where: "local filename" is local file to Get|Put (quotes required!)
         target filenames, unless specified, adopt source filenames
         'username:password' default to 'anonymous:my_Email_address'
         'B[inary]|a[scii] or d[elete]' defaults to 'Binary'
         'REXX.EXE' is required ONLY by Windows
  e.g.:  XYFTP ftp.boulder.ibm.com/software/asd/nsdicts/en_us/czech.dic B
         XYFTP "d:\path\MYPAGE.HTM" ftp.myisp.com/mydir/index.htm A
         XYFTP ftp.myisp.com/mydir/index.bak D

   THREE (3) USER DEFAULTS: */
username='anonymous' /* My Username (sometimes) */
password='holmgren@acedsl.com' /* My Email Address (usually) */
method='B' /* (B)inary or (a)scii; (d)elete
   END USER DEFAULTS */

un=username
pw=password
md=method
hf=''
sf=''
lf=''
parse arg url
if url='' then do
  say 'No args'
  exit
  end
if lastpos(' ',url)>0&lastpos(' ',url)=length(url)-1 then do
  md=translate(right(url,1))
  if pos(md,'ABD')=0 then md=method
  else url=left(url,length(url)-2)
  end
if pos('/',url)>0 then parse var url url'/'hf
if md\='D' then do
  if pos('"',url)=1&lastpos('" ',url)>1 then do /* PUT */
    sf=substr(url,2,lastpos('" ',url)-2)
    url=substr(url,lastpos('" ',url)+2)
    if stream(sf,'C','QUERY EXISTS')='' then do
      say 'File 'sf' not found'
      exit
      end
    end
  else if pos(' "',hf)>1&lastpos('"',hf)>pos(' "',hf)+1 then do /* GET */
    lf=substr(hf,pos(' "',hf)+2,lastpos('"',hf)-pos(' "',hf)-2)
    hf=left(hf,lastpos(' "',hf)-1)
    end
  if hf='' then hf=substr(sf,lastpos('\',sf)+1)
  if translate(md)\='A' then md='Binary'
  else md='Ascii'
  end
if pos('@',url)>0 then parse var url unpw'@'url
if pos(':',unpw)>0 then parse var unpw un':'pw
td='.'
if pos('/',hf)>0&pos('/',hf)\=lastpos('/',hf) then do
  td=left(hf,lastpos('/',hf)-1)
  hf=substr(hf,lastpos('/',hf)+1)
  end
if lf=''&md\='D' then do
  if length(directory())>3 then lf=directory()||'\'||hf
  else lf=directory()||hf
  end
rxutl=RxFuncQuery('SysLoadFuncs')
if rxutl then do
  call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
  call SysLoadFuncs
  end
rxftp=RxFuncQuery('FtpLoadFuncs')
if rxftp then do
  call RxFuncAdd 'FtpLoadFuncs','rxFtp','FtpLoadFuncs'
  call FtpLoadFuncs
  end
if FtpSetUser(url,un,pw) then do
  if td\='.' then do
    if FtpChDir(td)=0 then call Prc
    else say 'Invalid host target dir "'||td||'"'
    end
  else call Prc
  call FtpLogoff
  end
else say 'Invalid or unavailable host "'url'"'
if rxftp then call FtpDropFuncs
if rxutl then call SysDropFuncs
exit

PRC:
  if md='D' then do
    call Charout,'Deleting "'url'/'
    if td\='.' then call Charout,td'/'hf'"...'
    else call Charout,hf'"...'
    if FtpDelete(hf)=0 then say 'Done'
    else say 'Failed'
    return
    end
  if sf='' then do /* GET */
    call Charout,'Fetching "'url'/'
    if td\='.' then say td'/'hf'" to "'lf'"...'
    else say hf'" to "'lf'"...'
/* SAY 'td='td'- hf='hf'- md='md'- lf='lf'-' */
    if FtpGet(lf,hf,md)=0 then say 'Filed as "'lf'" ... Done'
    else say 'Invalid host filename "'||hf||'"'
    end
  else do /* PUT */
    call Charout,'Putting "'sf'" to "'url'/'
    if td\='.' then say td'/'hf'"...'
    else say hf'"...'
/* SAY 'td='td'- hf='hf'- md='md'- sf='sf'-' */
    if FtpPut(sf,hf,md)=0 then do
      call Charout,'Put "'url'/'
      if td\='.' then say td||hf'" ... Done'
      else say hf'"... Done'
      end
    else say 'Error putting "'||sf||'"'
    end
RETURN

