/****
 SW.REX v1.0  SWitch Processes for Windows 9x|ME|NT|2K [XYSHELL.ZIP]
 SWitch focus to already-running process, optionally using [sub]$tring
   of process title and/or aliases
 SW.REX requires RexxUtil.DLL version 2.00+ (IBM Object Rexx v1.0.3.0+)
 R.J.Holmgren  holmgren@acedsl.com  Freeware  13 May 2002

 Usage:   rexx sw.rex [process title [mask]] [/c]
          sw[.bat] [process title [mask]] [/c]
   no process title supplied = Display complete Tasklist
   special process title "*" = Display complete Tasklist
   spaces permitted in process title [mask]; quotes not required
   aliases may be hard-coded in SW.REX -- see "USER ALIASES", below
   optional argument "/c" terminates (EXITs) the parent process
     after focus is SWitched

 *********USER**VARIABLE:*********
Hard-Coded "Case" User Variable:
Process Name Case sEnSiTiVe(=1) or INsensitive(=0,Default) ?
      Set Case (=0|1) on next line */
Case=0
/*********************************/

'@echo off'

if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
if RxFuncQuery("SysSwitchSession") then do
  say 'SW.REX requires RexxUtil.DLL version 2.00+ (Object Rexx v1.0.3.0+)'
  call Help
  end
call SysSetPriority 2,15
signal on Halt
winMgr=.WindowsManager~new
if winMgr~initcode\=0 then do
  say "Can't get instance of WindowsManager - Aborting"
  signal Bye
  end

c='0D0A'x
alias=''
swtitle=''
sw=''

w2=rxqueue("get")
if w2='SWWIN' then do
  pull alias
  alias=x2c(alias)
  call rxqueue "delete","SWWIN"
  end
else parse arg alias
alias=strip(alias)
if translate(alias)='/C' then alias='* /C'
ex=0
if right(translate(alias),3)=' /C'&length(alias)>3 then do
  ex=1
  alias=left(alias,length(alias)-3)
  end

trn=translate(alias)
if trn='?'|trn='/?'|trn='-?'|trn='HELP'|trn='/HELP'|trn='-HELP' then call Help

select
/*   USER ALIASES ͻ
                        Example User Aliases:                      
    Enter aliases (synonyms) in following form (examples):         
     when alias='' then nop  /* display TaskList */                
                   below: show TaskList, KILL process]             
     when alias='' then swtitle='XyWrite IV'                       
     when alias='wt' then swtitle='WinTop'                         
     when alias='p' then swtitle='Program Manager'                 
     when alias='f' then swtitle='DOS FullScreen'                  
     when alias='w' then swtitle='DOS Window'                      
     when alias='j' then swtitle='JStreet Mailer'                  
                                                                   
    One alias per line.  Add new lines as necessary.               
    Aliases are case SeNsItIvE!                                    
    Enter your personal aliases BELOW using WHEN...THEN format:  
    ---------- DO   NOT   WRITE   ABOVE   THIS   LINE! ----------- 
             BEGINNING   OF   USER-ALIAS   ENTRY   SPACE            */
  when alias='f' then swtitle='DOS FullScreen'
  
  
/*              END   OF   USER-ALIAS   ENTRY   SPACE              
   ͼ */

when alias='*' then swtitle=''
otherwise
  swtitle=alias
  end

j=0
agin:
if swtitle\='' then do
  call QuerySwitchList
  do i=1 to x
/* Swtitle INsensitive Case=0 */
    if Case=0 then do
      if pos(translate(swtitle),translate(prg.i~Title)||' {'||prg.i~Handle||'}')>0 then do
        j=j+1
        hit.j=prg.i
        end
      end
/* Swtitle SeNsItIvE Case=1 */
    else do
      if pos(swtitle,prg.i~Title||' {'||prg.i~Handle||'}')>0 then do
        j=j+1
        hit.j=prg.i
        end
      end
    end

  if j\=1 then call FocusSw
  if j>1 then do
    say 'Multiple "*'swtitle'*" processes found:'
    k=0;lin=0
    do until k=j
      k=k+1;lin=lin+1
      call Charout,'  '||k||': '
      if pos(c,hit.k~Title)>0 then do
        d=hit.k~Title
        call Remcr
        say ' {'hit.k~Handle'}'
        end
      else say hit.k~Title' {'hit.k~Handle'}'
      if lin=22 then call Pause
      end
    call Charout ,"Pick process 1-"||j||", otherwise display Tasklist: "
    call Getit
    if c2d(k)=27 then signal ab
    if y>j|length(y)=0|y=0 then do
      j=-1  /* Don't Switch to SW.REX twice */
      swtitle=''
      call SysCls
      signal agin
      end
    else do until pos('Foreground',hit.y~State)>0
      call SysSwitchSession hit.y~Title
      hit.y~ToForeground
      if pos('Min',hit.y~State)>0 then hit.y~Restore
      end
    end
  if j=1 then do until pos('Foreground',hit.j~State)>0
    call SysSwitchSession hit.j~Title
    hit.j~ToForeground
    if pos('Min',hit.j~State)>0 then hit.j~Restore
    end
  if j=0 then do
    say 'Process "*'swtitle'*" not found'
    j=-1
    swtitle=''
    signal agin
    end
  end
else do
  call QuerySwitchList
  call FocusSw
  say 'Tasklist:'
  j=0;lin=0
  do i=1 to x
      j=j+1;lin=lin+1
      hit.j=prg.i
      call Charout,'  '||j||': '
      if pos(c,hit.j~Title)>0 then do
        d=prg.i~Title
        call Remcr
        say ' {'prg.i~Handle'}'
        end
      else say hit.j~Title' {'hit.j~Handle'}'
    if lin=22 then call Pause
    end
  call Charout ,"Pick process 1-"||j||", otherwise Abort: "
  call Getit
  if y>j|length(y)=0|y=0 then do
    ab:
    say 'Abort'
    signal bye
    end
  else do until pos('Foreground',hit.y~State)>0
    call SysSwitchSession hit.y~Title
    hit.y~ToForeground
    if pos('Min',hit.y~State)>0 then hit.y~Restore
    end
  end

BYE:
  winMgr~Deinstall
  if ex then 'exit'
  exit
RETURN

QUERYSWITCHLIST:
x=0
pm=winMgr~Find~First
do until pos('NIL',pm)>0
  /* Skip Invisible Windows + SysTray */
  if pos('Inv',pm~State)<1&pos('Shell_TrayWnd',pm~WClass)<1&pos('tooltips',pm~WClass)<1&pm~Title\='' then do
/*     if (pm~Title='REXX'|pos('SW.REX',translate(pm~Title))>0)&sw='' then sw=pm */
    if pos('Foreground',pm~State)>0&sw='' then sw=pm
/*     if pos('SW.REX',translate(pm~Title))=0&&(translate(pm~Title)='REXX'&w2\='SWWIN') then do */
/*     if translate(pm~Title)\='REXX'&pos('SW.REX',translate(pm~Title))=0 then do */
    if pos('Foreground',pm~State)=0 then do
      x=x+1
      prg.x=pm
      end
    end
  pm=pm~Next
  end
RETURN

FOCUSSW:
  do until pos('Foreground',sw~State)>0
    call SysSwitchSession sw~Title
    sw~ToForeground
    if pos('Min',sw~State)>0 then sw~Restore
    end
RETURN

GETIT:
  y=''
  do until y*10>j|length(y)=0|y=0
    k=SysGetKey()
    if c2d(k)=13 then leave
    y=y||k
    if c2d(k)=27|verify(k,'0123456789')>0 then y=0
    end
  say
RETURN

HALT:
  signal ab
RETURN

PAUSE:
  call Charout,'Hit a key to continue'
  call SysGetKey 'noecho'
  say
  lin=0
RETURN

REMCR:
  do until pos(c,d)=0
    d=substr(d,1,pos(c,d)-1)||' '||substr(d,pos(c,d)+2)
    end
  call Charout,d
RETURN

HELP:
  say 'SW.REX  Freeware  R.J.Holmgren  13 May 2002'
  say 'SWitch focus to already-running process from DOS command line or DOS shell;'
  say '	optionally supply [sub]$tring of process title and/or aliases'
  say
  say 'Usage:	DOS Commands  [Optional] Arguments'
  say '	>-- -------<  >--------- --------<'
  say '	REXX SW[.REX] [process title [mask]] [/c]   opens in Desktop Window'
  say '	SW[.BAT]      [process title [mask]] [/c]   opens DOS Full Screen'
  say '		process title [mask]		[partial] title in Tasklist'
  say '		empty "" or "*" process title	display complete Tasklist'
  say '		aliases may be hard-coded in SW.REX'
  say '		/C terminates command line process after focus is SWitched'
  exit
RETURN

::requires "WINSYSTM.CLS"   /* access class definitions */

