/****
 W2.REX XyShell v1.0 for Windows 9x|NT|2K|XP [XYSHELL.ZIP]
 Start Windows process from XyWrite IV+
 W2.REX requires RexxUtil.DLL version 2.00+ (IBM Object Rexx v1.0.3.0+)
 R.J.Holmgren  holmgren@acedsl.com  Freeware  4 August 2002

 Non-START command line switches:
 /E                       Turn ECHO ON during execution
 /H                       Halt before exiting shell
 /I                       Ignore W2-ALIAS.DAT (omit alias query)
 /L:program_to_launch     Monitor Launched program|object until inactive
 /L:"program to launch"     ditto (spaces in program filename)
                            (try /Z first)
 /LW:seconds_to_wait      wait seconds for program to launch (default=4)
 /P:"exit process title"  On-the-fly "ExitProc" definition
 /P:#                     Launch but do NOT return (exit immediately)
 /R                       Execute as REXX script, not batch commands
 /Z                       Zoom (focus) W2.REX session
                            (if unsuccessful, use /L) */

                              /* Load RexxUtil v2.00 */
if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end

/*******TWO**USER**VARIABLES:*******
1. Rexx Installation Directory (REXX.EXE,*.REX,*.CMD,*.BAT,W2-ALIAS.DAT):
Default=[bootdrive:]\ObjREXX
No adjustment necessary if you installed to [BootDrive]:\PROGRA~1\ObjREXX
         Set RexxDir on next line, e.g. RexxDir='C:\PROGRA~1\ObjREXX' */
RexxDir=SysBootDrive()||'\PROGRA~1\ObjREXX'

/*
2. Hard-Coded "Case" User Variable:
Process Name Case sEnSiTiVe(=1) or INsensitive(=0=Default) ?
      Set Case (=0|1) on next line! */
Case=0
/***********************************/

if RxFuncQuery("SysSwitchSession") then do
  say 'W2.REX requires RexxUtil.DLL version 2.00+ (Object Rexx v1.0.3.0+)'
  call Help
  end
call SysSetPriority 2,15
signal on halt
winMgr=.WindowsManager~new
if winMgr~initcode\=0 then do
  call Charout,"Can't get instance of WindowsManager - "
  signal Halt
  end

                              /* Set|Verify filenames */
IniFile=RexxDir||'\W2.INI'
currdir=directory()

linein(IniFile,1,0)           /* (Re)Set Read/Write Position */
if lines(IniFile)=0 then call Help

args=linein(IniFile)          /* Read W2.INI */
ucargs=translate(args)
Command=linein(IniFile)

do until x=0
  x=pos('%ROOT%',translate(Command))
  if x>0 then Command=left(Command,x-1)||SysBootDrive()||'\'||substr(Command,x+6)
  end

/* if pos('/B',ucargs)>0 then do /* Strip inadvertent OS/2 command */
  do until pos('/B',ucargs)=0
    ucargs=left(ucargs,pos('/B',ucargs)-1)||substr(ucargs,pos('/B',ucargs)+2)
    end
  ucargs=ucargs||' /MIN '
  end */

agin:  /* Get environment %VARIABLES% in Command, if exist */
if pos('%',Command)>0 then do
  TmpCmnd=substr(Command,pos('%',Command)+1)
  if pos('%',TmpCmnd)>0 then do
    TmpCmnd=left(TmpCmnd,pos('%',TmpCmnd)-1)
    x=value(TmpCmnd,,'ENVIRONMENT')
    if length(x)>0 then do
      Command=left(Command,pos('%',Command)-1)||x||substr(Command,pos('%',Command)+length(TmpCmnd)+2)
      signal agin
      end
    end
  end

call stream IniFile,'C','close' /* Close W2.INI */

/* Read user input (W2 args) */

fswin=2
if pos('NT',SysWinVer())>0 then do
  if pos('/FS',ucargs)>0 then fswin=1   /* /FS ignores /MIN */
  else if pos('/WIN',ucargs)>0 then fswin=0   /* /FS overrides /WIN */
  if fswin<2 then do
    r=.WindowsRegistry~new
    if r~InitCode=0 then do
      if r~open(r~Current_User,"Console")\=0 then do
        if pos('5.',SysWinVer())>0 then do /* if Win2000 */
          if r~open(r~Current_Key,"%SystemRoot%_system32_cmd.exe")\=0 then x.=r~getvalue(,"FullScreen") /* Get next subkey */
           end
        else x.=r~getvalue(,"FullScreen")
        if pos(x.data,'01')>0 then do
          if fswin\=x.data then do
            r~setvalue(,"FullScreen",fswin,"NUMBER")
            command='START '
            if fswin=0&pos('/MIN',ucargs)>0 then command=command||'/MIN '
            command=command||RexxDir||'\W2.BAT'
            if fswin=0&pos('/MIN',ucargs)>0 then command=command||' M'
            command
            exit  /* restart W2.BAT if toggle FullScreen<>Window */
            end
          end
        end
      end
    end
  end
hold=0; if pos('/H',ucargs)>0 then hold=1
if pos('/E',ucargs)>0 then '@echo on'
else '@echo off'
rexxon=0; if pos('/R',ucargs)>0 then rexxon=1
/* Killing "/B" argument -- not realistic under Windows! */
backoff=1;if pos('/MIN',ucargs)>0&fswin\=1 then backoff=0

/* NEW on 5/16/02 */
delay=4
x=pos('/LW:',ucargs)
if x>0 then do
  delay=substr(ucargs,x+4,pos(' ',ucargs,x+4)-x-4)
  if verify(delay,'0123456789')>0 then delay=4
  end

lname=''
x=pos('/L:',ucargs)
if x>0 then do
  x1=pos('/L:"',ucargs)
  if x=x1 then do
    lname=substr(args,x+4)
    x=pos('"',lname)
    end
  else do
    lname=substr(args,x+3)
    x=pos(' ',lname)
    end
  if x>0 then lname=substr(lname,1,x-1)
  end
/* END NEW */

ExitProc=''
x=pos('/P:',ucargs)
if x>0 then do
  x1=pos('/P:"',ucargs)
  if x=x1 then do
    ExitProc=substr(args,x+4)
    x=pos('"',ExitProc)
    end
  else do
    ExitProc=substr(args,x+3)
    x=pos(' ',ExitProc)
    end
  if x>0 then ExitProc=substr(ExitProc,1,x-1)
  end
/* if ExitProc='#' then ExitProc='' */

c='0D0A'x
dr=''
dirs=''
dirs1=''
fn=''
hndl=''
pause=1
quot=""""
verify=''
w2=''

Command=strip(Command) /* Strip leading+trailing spaces */
/* if backoff=0&pos('/MIN',translate(Command))=0&pos('START',translate(Command))\=1&rexxon=0 then Command='START /MIN '||Command */
TmpCmnd=Command

x=pos('CALL ',translate(TmpCmnd))  /* Get drive/dir/filename of Command */
if x=1 then TmpCmnd=substr(TmpCmnd,x+5)
x=pos('START ',translate(TmpCmnd))
if x=1 then TmpCmnd=substr(TmpCmnd,x+6)
do while pos('/',TmpCmnd)=1
  x=pos(' ',TmpCmnd)
  if x>0 then TmpCmnd=substr(TmpCmnd,x+1)
  end
x=pos(' ',TmpCmnd)
if x>0 then TmpCmnd=substr(TmpCmnd,1,x-1)
if TmpCmnd='' then call Help
if pos('/MIN',TmpCmnd)>0 then backoff=0

if pos('/',TmpCmnd)=0 then verify=stream(TmpCmnd,'C','query exists') /* Set drive/dir/filename of command */
if Verify\='' then do
  dr=filespec("drive",TmpCmnd)
  dirs=filespec("path",TmpCmnd)
  dirs1=dirs
  if length(dirs)>1 then dirs1=left(dirs,length(dirs)-1)
  fn=filespec("name",TmpCmnd)
  end

if dr\='' then dr    /* Execute command */
if dirs1\='' then 'cd' dirs1
if rexxon|pos('CALL ',translate(Command))=1 then do   /* If Rexx... */
  if backoff then do
    call QuerySwitchList
    do until pos('Foreground',w2~State)>0
      call SysSwitchSession w2~Title
      w2~ToForeground
      if pos('Min',w2~State)>0 then w2~Restore
      call SysSleep 1
      end
    Command='"'||RexxDir||'\rexx.exe '||RexxDir||'\requery.rex 'hndl'";'Command
    end
  interpret Command
  end
else do
  /* Otherwise launch Program */
/*   ps=pos(' ',Command);if ps=0 then ps=1000 */
  pp=pos('.PIF',translate(Command))
  if pp<pos('.LNK',translate(Command)) then pp=pos('.LNK',translate(Command))
  if pp>0&pos('START',translate(Command))\=1 then Command='START '||Command
  if ExitProc='#'&pos('START',translate(Command))\=1 then Command='START '||Command
  if pos('START',translate(Command))=1&pos('/MIN',translate(Command))=0|pos('/L',ucargs)>0|pos('/Z',ucargs)>0 then do
    pm=winMgr~Find~First
    x3=0
    do until pos('NIL',pm)>0
      x3=x3+1
      pm1.x3=pm~Title
      if (pm1.x3='REXX'|pos('W2',translate(pm1.x3))>0)&backoff then do until pos('Foreground',pm~State)>0
        call SysSwitchSession pm1.x3
        pm~ToForeground
        if pos('Min',pm~State)>0 then pm~Restore
        call SysSleep 1
        end
      pm=pm~Next
      end
    Command
    if pos('/Z',ucargs)=0 then do
      call SysSleep 1
      pm=winMgr~Find~First
      x2=''
      do until pos('NIL',pm)>0|length(x2)>0
        do i=1 to x3
          x2=''
          if pm1.i=pm~Title then leave
          x2=pm~Title
          if x2='REXX'|pos('W2',translate(x2))>0|pos('Disabled',pm~State)>0 then x2=''
          else hndl=pm~Handle
          end
        pm=pm~Next
        end
      if length(x2)>0&ExitProc\='#' then do until pos('NIL',pm)>0
/*         call SysSleep 1 */
        pm=winMgr~Find(x2)
        if pos('NIL',pm)=0&backoff then do
          if hndl\=pm~Handle then pm='NIL'
/* NEW 5/16/02 */
          else do
/*   */           call SysSwitchSession pm
            pm~ToForeground
            if pos('Min',pm~State)>0 then pm~Restore
            end
/* END NEW */
          end
        end
      end
    end
  else do
    Command
    end
  end

Continue: /* Put "Signal on Halt name Continue" in child program for Ctrl-C */
Signal on Halt name Halt
if lname\=''&backoff then do
  say 'Monitoring persistence of process "*'lname'*"; Ctrl-C aborts...'
  dly=0
  do forever
    call SysSleep 1
    dly=dly+1
    pm=winMgr~Find~First
    x2=1
    do until pos('NIL',pm)>0|x2=0
      if pos(translate(lname),translate(pm~Title))>0 then x2=0
      pm=pm~Next
      end
    if x2&dly>delay then leave
    end
  end
if hold=1&pause=1 then do    /* Don't pause twice */
  call charout ,'-- Hit any key to switch to 'quot||ExitProc||quot' --'
  call SysGetKey 'noecho'
  end

if ExitProc\=''&ExitProc\='#' then do
  j=0; a=0
  call QuerySwitchList
  do i=1 to x
    if pos('REXX',list.i)<1&pos('W2',translate(list.i))=0 then do
      if case=0 then do
        if pos(translate(ExitProc),translate(list.i))>0 then do   /* Case INsensitive */
          j=j+1
          hit.j=prg.i
          end
        end
      else do
        if pos(ExitProc,list.i)>0 then do   /* Case SeNsItIvE */
          j=j+1
          hit.j=prg.i
          end
        end
      end
    end
  if j=1 then do until pos('Foreground',hit.1~State)>0
    call SysSwitchSession hit.1~Title
    hit.1~ToForeground
    if pos('Min',hit.1~State)>0 then hit.1~Restore
    call SysSleep 1
    end
  else do
    if backoff then do
      call rxqueue "create","SWWIN"
      call rxqueue "set","SWWIN"
      ExitProc=c2x(ExitProc)
      push ExitProc
      call Bye
      if hold=1 then say
      interpret "call '"||RexxDir||"\SW.REX'"
      exit
      end
    end
  end
call Bye
exit

QUERYSWITCHLIST:
x=0
pm=winMgr~Find~First
do until pos('NIL',pm)>0
  /* Skip Invisible Windows + SysTray */
  if pos('Inv',pm~State)<1&pos('Shell_TrayWnd',pm~WClass)<1&pos('tooltips',pm~WClass)<1&pm~Title\='' then do
    x=x+1
    prg.x=pm
    list.x=pm~Title
    if translate(list.x)='REXX'|pos('W2',translate(list.x))>0|pos('REXX.EXE',translate(list.x))>0 then do
      if w2='' then w2=pm
      if hndl='' then hndl=pm~Handle
      end
    end
  pm=pm~Next
  end
RETURN

BYE:
  if x1=0 then call directory currdir
/*   call SysFileDelete IniFile */
  winMgr~Deinstall
RETURN

HALT:
/*   call SysFileDelete IniFile */
  winMgr~Deinstall
  say 'Abort'
  exit
RETURN

HELP:
  say
  say 'W2.REX v1.0 [XYSHELL.ZIP]  R.J.Holmgren  4 August 2002'
  say 'Execute Windows commands from XyWrite IV(+) Word Processor'
  say
  say 'W2.REX is initiated by XYWWWEB.U2 frames "s2" or "w2";'
  say '  W2.REX is not run directly from a Windows command line!'
  say 'For Help, command "s2<Helpkey>" in XyWrite, or consult XYSHELL.DOC'
  exit
RETURN

::requires "WINSYSTM.CLS"   /* access class definitions */

