/* Xy-Shell Set_Console Utility, for Windows NT|2000 v1.1
Establish DOS (CMD.EXE) session default under NT:  FullScreen or Window
R.J.Holmgren 12/9/2001 */

if RxFuncQuery("SysLoadFuncs") then do
  call RxFuncAdd "SysLoadFuncs","RexxUtil","SysLoadFuncs"
  call SysLoadFuncs
  end
if pos('NT',SysWinVer())>0 then do
  parse arg fswin
  fswin=strip(fswin)
  fswin=translate(fswin)
  if pos('W',fswin)=1 then fswin='0'  /* Window */
  if pos('F',fswin)=1 then fswin='1'  /* Full Screen */
  if pos(fswin,'01')>0 then do
    r=.WindowsRegistry~new
    if r~InitCode=0 then do
      if r~open(r~Current_User,"Console")\=0 then do
        if pos('5.',SysWinVer())>0 then do /* if Win2000 */
          if r~open(r~Current_Key,"%SystemRoot%_system32_cmd.exe")=0 then exit 7 /* Get next subkey; abort if can't open "%SystemRoot%_system32_cmd.exe" key */
          end
        x.=r~getvalue(,"FullScreen")
        if pos(x.data,'01')>0 then do
          call Charout,'XYSHLCON:  DOS session default='
          if fswin=0 then say 'Window'
          else say 'FullScreen'
          if fswin\=x.data then do
            r~setvalue(,"FullScreen",fswin,"NUMBER")
            exit 1  /* quit on Change */
            end
          else exit 0  /* quit on No_Change */
          end
        else exit 2  /* abort if bad existing "FullScreen" data */
        end
      else exit 3  /* abort if can't open "Console" key */
      end
    else exit 4  /* abort if can't initialize WindowsRegistry */
    end
  else do /* abort if bad argument */
    say 'XYSHLCON.REX'
    say 'Xy-Shell Set_Console Utility, for Windows NT  R.J.Holmgren v1.1 12/9/01'
    say 'Establish DOS (CMD.EXE) session default under NT:  Window or FullScreen'
    say
    say 'Command: [d:\path\]REXX.EXE [d:\path\]XYSHLCON.REX argument'
    say '						   0|W[indow]'
    say '						   1|F[ullScreen]'
    say 'e.g. REXX XYSHLCON.REX 1<cr>'
    exit 5
    end
  end
else exit 6  /* abort if wrong OpSys */
exit

::requires "WINSYSTM.CLS"
